/* This file was autogenerated by the usplash-manager software
 *
 * usplash-manager help you to create and manage your usplash theme
 * for more information: https://launchpad.net/~usplash-manager
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 *  
 */

#include <usplash-theme.h>
/* Needed for the custom drawing functions */
#include <usplash_backend.h>
#include "usplash_horizontale.c"

/* Pixmap structure for theme images */
extern struct usplash_pixmap pixmap_throbber_back;
extern struct usplash_pixmap pixmap_throbber_fore;
extern struct usplash_pixmap pixmap_usplash_1024_640;
extern struct usplash_pixmap pixmap_usplash_1024_768;
extern struct usplash_pixmap pixmap_usplash_1280_1024;
extern struct usplash_pixmap pixmap_usplash_1280_720;
extern struct usplash_pixmap pixmap_usplash_1280_800;
extern struct usplash_pixmap pixmap_usplash_1440_900;
extern struct usplash_pixmap pixmap_usplash_1600_1200;
extern struct usplash_pixmap pixmap_usplash_1680_1050;
extern struct usplash_pixmap pixmap_usplash_640_480;
extern struct usplash_pixmap pixmap_usplash_800_600;

/* Custom drawing functions prototypes */
void t_init(struct usplash_theme* theme);
void t_clear_progressbar(struct usplash_theme* theme);
void t_draw_progressbar(struct usplash_theme* theme, int percentage);
void t_animate_step(struct usplash_theme* theme, int pulsating);

/* usplash_theme declaration */
struct usplash_theme usplash_theme_800_600;
struct usplash_theme usplash_theme_1024_640;
struct usplash_theme usplash_theme_1024_768;
struct usplash_theme usplash_theme_1280_1024;
struct usplash_theme usplash_theme_1280_720;
struct usplash_theme usplash_theme_1280_800;
struct usplash_theme usplash_theme_1440_900;
struct usplash_theme usplash_theme_1600_1200;
struct usplash_theme usplash_theme_1680_1050;


/* Theme definitions */
struct usplash_theme usplash_theme = {
    .version = THEME_VERSION, /* ALWAYS set this to THEME_VERSION, 
                                 it's a compatibility check */
    .next  = &usplash_theme_800_600,
    .ratio = USPLASH_4_3,

    /* Background and font */
    .pixmap = &pixmap_usplash_640_480,

    /* Palette indexes */
    .background             = 0,
    .progressbar_background = 32,
    .progressbar_foreground = 131,
    .text_background        = 0,
    .text_foreground        = 1,
    .text_success           = 2,
    .text_failure           = 3,

    /* Progress bar position and size in pixels */
    .progressbar_x      = 160,
    .progressbar_y      = 307,
    .progressbar_width  = 320,
    .progressbar_height = 29.0,

    /* Text box position and size in pixels */
    .text_x      = 204,
    .text_y      = 386,
    .text_width  = 243,
    .text_height = 91,

    /* Text details */
    .line_height  = 15,
    .line_length  = 32,
    .status_width = 35,

    /* Functions */
    .init = t_init,
    .clear_progressbar = t_clear_progressbar,
    .draw_progressbar = t_draw_progressbar,
    .animate_step = t_animate_step,
};
struct usplash_theme usplash_theme_800_600 = {
    .version = THEME_VERSION, /* ALWAYS set this to THEME_VERSION, 
                                 it's a compatibility check */
    .next  = &usplash_theme_1024_640,
    .ratio = USPLASH_4_3,

    /* Background and font */
    .pixmap = &pixmap_usplash_800_600,

    /* Palette indexes */
    .background             = 0,
    .progressbar_background = 32,
    .progressbar_foreground = 131,
    .text_background        = 0,
    .text_foreground        = 1,
    .text_success           = 2,
    .text_failure           = 3,

    /* Progress bar position and size in pixels */
    .progressbar_x      = 240,
    .progressbar_y      = 387,
    .progressbar_width  = 320,
    .progressbar_height = 29.0,

    /* Text box position and size in pixels */
    .text_x      = 256,
    .text_y      = 483,
    .text_width  = 304,
    .text_height = 114,

    /* Text details */
    .line_height  = 15,
    .line_length  = 32,
    .status_width = 35,

    /* Functions */
    .init = t_init,
    .clear_progressbar = t_clear_progressbar,
    .draw_progressbar = t_draw_progressbar,
    .animate_step = t_animate_step,
};
struct usplash_theme usplash_theme_1024_640 = {
    .version = THEME_VERSION, /* ALWAYS set this to THEME_VERSION, 
                                 it's a compatibility check */
    .next  = &usplash_theme_1024_768,
    .ratio = USPLASH_16_9,

    /* Background and font */
    .pixmap = &pixmap_usplash_1024_640,

    /* Palette indexes */
    .background             = 0,
    .progressbar_background = 32,
    .progressbar_foreground = 131,
    .text_background        = 0,
    .text_foreground        = 1,
    .text_success           = 2,
    .text_failure           = 3,

    /* Progress bar position and size in pixels */
    .progressbar_x      = 352,
    .progressbar_y      = 414,
    .progressbar_width  = 320,
    .progressbar_height = 29.0,

    /* Text box position and size in pixels */
    .text_x      = 327,
    .text_y      = 515,
    .text_width  = 389,
    .text_height = 121,

    /* Text details */
    .line_height  = 15,
    .line_length  = 32,
    .status_width = 35,

    /* Functions */
    .init = t_init,
    .clear_progressbar = t_clear_progressbar,
    .draw_progressbar = t_draw_progressbar,
    .animate_step = t_animate_step,
};
struct usplash_theme usplash_theme_1024_768 = {
    .version = THEME_VERSION, /* ALWAYS set this to THEME_VERSION, 
                                 it's a compatibility check */
    .next  = &usplash_theme_1280_1024,
    .ratio = USPLASH_4_3,

    /* Background and font */
    .pixmap = &pixmap_usplash_1024_768,

    /* Palette indexes */
    .background             = 0,
    .progressbar_background = 32,
    .progressbar_foreground = 131,
    .text_background        = 0,
    .text_foreground        = 1,
    .text_success           = 2,
    .text_failure           = 3,

    /* Progress bar position and size in pixels */
    .progressbar_x      = 352,
    .progressbar_y      = 500,
    .progressbar_width  = 320,
    .progressbar_height = 29.0,

    /* Text box position and size in pixels */
    .text_x      = 327,
    .text_y      = 618,
    .text_width  = 389,
    .text_height = 145,

    /* Text details */
    .line_height  = 15,
    .line_length  = 32,
    .status_width = 35,

    /* Functions */
    .init = t_init,
    .clear_progressbar = t_clear_progressbar,
    .draw_progressbar = t_draw_progressbar,
    .animate_step = t_animate_step,
};
struct usplash_theme usplash_theme_1280_1024 = {
    .version = THEME_VERSION, /* ALWAYS set this to THEME_VERSION, 
                                 it's a compatibility check */
    .next  = &usplash_theme_1280_720,
    .ratio = USPLASH_16_9,

    /* Background and font */
    .pixmap = &pixmap_usplash_1280_1024,

    /* Palette indexes */
    .background             = 0,
    .progressbar_background = 32,
    .progressbar_foreground = 131,
    .text_background        = 0,
    .text_foreground        = 1,
    .text_success           = 2,
    .text_failure           = 3,

    /* Progress bar position and size in pixels */
    .progressbar_x      = 480,
    .progressbar_y      = 671,
    .progressbar_width  = 320,
    .progressbar_height = 29.0,

    /* Text box position and size in pixels */
    .text_x      = 409,
    .text_y      = 824,
    .text_width  = 486,
    .text_height = 194,

    /* Text details */
    .line_height  = 15,
    .line_length  = 32,
    .status_width = 35,

    /* Functions */
    .init = t_init,
    .clear_progressbar = t_clear_progressbar,
    .draw_progressbar = t_draw_progressbar,
    .animate_step = t_animate_step,
};
struct usplash_theme usplash_theme_1280_720 = {
    .version = THEME_VERSION, /* ALWAYS set this to THEME_VERSION, 
                                 it's a compatibility check */
    .next  = &usplash_theme_1280_800,
    .ratio = USPLASH_16_9,

    /* Background and font */
    .pixmap = &pixmap_usplash_1280_720,

    /* Palette indexes */
    .background             = 0,
    .progressbar_background = 32,
    .progressbar_foreground = 131,
    .text_background        = 0,
    .text_foreground        = 1,
    .text_success           = 2,
    .text_failure           = 3,

    /* Progress bar position and size in pixels */
    .progressbar_x      = 480,
    .progressbar_y      = 467,
    .progressbar_width  = 320,
    .progressbar_height = 29.0,

    /* Text box position and size in pixels */
    .text_x      = 409,
    .text_y      = 580,
    .text_width  = 486,
    .text_height = 136,

    /* Text details */
    .line_height  = 15,
    .line_length  = 32,
    .status_width = 35,

    /* Functions */
    .init = t_init,
    .clear_progressbar = t_clear_progressbar,
    .draw_progressbar = t_draw_progressbar,
    .animate_step = t_animate_step,
};
struct usplash_theme usplash_theme_1280_800 = {
    .version = THEME_VERSION, /* ALWAYS set this to THEME_VERSION, 
                                 it's a compatibility check */
    .next  = &usplash_theme_1440_900,
    .ratio = USPLASH_16_9,

    /* Background and font */
    .pixmap = &pixmap_usplash_1280_800,

    /* Palette indexes */
    .background             = 0,
    .progressbar_background = 32,
    .progressbar_foreground = 131,
    .text_background        = 0,
    .text_foreground        = 1,
    .text_success           = 2,
    .text_failure           = 3,

    /* Progress bar position and size in pixels */
    .progressbar_x      = 480,
    .progressbar_y      = 521,
    .progressbar_width  = 320,
    .progressbar_height = 29.0,

    /* Text box position and size in pixels */
    .text_x      = 409,
    .text_y      = 644,
    .text_width  = 486,
    .text_height = 152,

    /* Text details */
    .line_height  = 15,
    .line_length  = 32,
    .status_width = 35,

    /* Functions */
    .init = t_init,
    .clear_progressbar = t_clear_progressbar,
    .draw_progressbar = t_draw_progressbar,
    .animate_step = t_animate_step,
};
struct usplash_theme usplash_theme_1440_900 = {
    .version = THEME_VERSION, /* ALWAYS set this to THEME_VERSION, 
                                 it's a compatibility check */
    .next  = &usplash_theme_1600_1200,
    .ratio = USPLASH_16_9,

    /* Background and font */
    .pixmap = &pixmap_usplash_1440_900,

    /* Palette indexes */
    .background             = 0,
    .progressbar_background = 32,
    .progressbar_foreground = 131,
    .text_background        = 0,
    .text_foreground        = 1,
    .text_success           = 2,
    .text_failure           = 3,

    /* Progress bar position and size in pixels */
    .progressbar_x      = 560,
    .progressbar_y      = 588,
    .progressbar_width  = 320,
    .progressbar_height = 29.0,

    /* Text box position and size in pixels */
    .text_x      = 460,
    .text_y      = 724,
    .text_width  = 547,
    .text_height = 171,

    /* Text details */
    .line_height  = 15,
    .line_length  = 32,
    .status_width = 35,

    /* Functions */
    .init = t_init,
    .clear_progressbar = t_clear_progressbar,
    .draw_progressbar = t_draw_progressbar,
    .animate_step = t_animate_step,
};
struct usplash_theme usplash_theme_1600_1200 = {
    .version = THEME_VERSION, /* ALWAYS set this to THEME_VERSION, 
                                 it's a compatibility check */
    .next  = &usplash_theme_1680_1050,
    .ratio = USPLASH_4_3,

    /* Background and font */
    .pixmap = &pixmap_usplash_1600_1200,

    /* Palette indexes */
    .background             = 0,
    .progressbar_background = 32,
    .progressbar_foreground = 131,
    .text_background        = 0,
    .text_foreground        = 1,
    .text_success           = 2,
    .text_failure           = 3,

    /* Progress bar position and size in pixels */
    .progressbar_x      = 640,
    .progressbar_y      = 789,
    .progressbar_width  = 320,
    .progressbar_height = 29.0,

    /* Text box position and size in pixels */
    .text_x      = 512,
    .text_y      = 966,
    .text_width  = 608,
    .text_height = 228,

    /* Text details */
    .line_height  = 15,
    .line_length  = 32,
    .status_width = 35,

    /* Functions */
    .init = t_init,
    .clear_progressbar = t_clear_progressbar,
    .draw_progressbar = t_draw_progressbar,
    .animate_step = t_animate_step,
};
struct usplash_theme usplash_theme_1680_1050 = {
    .version = THEME_VERSION, /* ALWAYS set this to THEME_VERSION, 
                                 it's a compatibility check */
    .next  = NULL,
    .ratio = USPLASH_16_9,

    /* Background and font */
    .pixmap = &pixmap_usplash_1680_1050,

    /* Palette indexes */
    .background             = 0,
    .progressbar_background = 32,
    .progressbar_foreground = 131,
    .text_background        = 0,
    .text_foreground        = 1,
    .text_success           = 2,
    .text_failure           = 3,

    /* Progress bar position and size in pixels */
    .progressbar_x      = 680,
    .progressbar_y      = 689,
    .progressbar_width  = 320,
    .progressbar_height = 29.0,

    /* Text box position and size in pixels */
    .text_x      = 537,
    .text_y      = 845,
    .text_width  = 638,
    .text_height = 199,

    /* Text details */
    .line_height  = 15,
    .line_length  = 32,
    .status_width = 35,

    /* Functions */
    .init = t_init,
    .clear_progressbar = t_clear_progressbar,
    .draw_progressbar = t_draw_progressbar,
    .animate_step = t_animate_step,
};


/* Initialisation and drawing functions */
void t_init(struct usplash_theme *theme) {
    int x, y;
    usplash_getdimensions(&x, &y);
    theme->progressbar_x = (x - theme->pixmap->width)/2 + theme->progressbar_x;
    theme->progressbar_y = (y - theme->pixmap->height)/2 + theme->progressbar_y;
}

void t_clear_progressbar(struct usplash_theme *theme) {
    usplash_put(theme->progressbar_x, theme->progressbar_y, &pixmap_throbber_back);
}

void t_draw_progressbar(struct usplash_theme *theme, int percentage) {
    if(percentage == 0)
        usplash_put(theme->progressbar_x, theme->progressbar_y, &pixmap_throbber_back);
    if(percentage < 0){/* Unloading */
	right_left(theme, &pixmap_throbber_back, & pixmap_throbber_fore, percentage);	  
    }
    else{/* Loading */
	left_right(theme, &pixmap_throbber_back, & pixmap_throbber_fore, percentage);
    }
}

void t_animate_step(struct usplash_theme* theme, int pulsating) {

    if (pulsating) {
        pulsate(theme, &pixmap_throbber_back, &pixmap_throbber_fore);
    }
}
